#include "OthelloApp.h"

#include <iostream>
#include <fstream>
#include <string>
#include "FKUT/Misc.h"


OthelloApp::OthelloApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin), tb(argDrawWin, &camera)
{
	// EBhEփV[o^
	drawWin->setScene(&scene);
}

OthelloApp::~OthelloApp(void)
{
	// EBhEV[̓o^
	drawWin->setScene(NULL);
}

void OthelloApp::init(void)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setDiffuse(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// Ֆʍ쐬͊֐
	setupBoard();

	// ΂̌
	stoneNum = 0;
	// ΂̊{`sph1g񂷂Ƃɂ
	sph.makeSphere(6, 4.0);
	// zu4
	makeStone(fk_Vector( 5.0, 0.25,  5.0));
	makeStone(fk_Vector(-5.0, 0.25,  5.0));
	makeStone(fk_Vector(-5.0, 0.25, -5.0));
	makeStone(fk_Vector( 5.0, 0.25, -5.0));

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5, 0.5, 0.5);
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&gridModel);
	scene.entryModel(&lightModel);

	// eLXgEl\p
	textSpr.initFont("C:/Windows/Fonts/Meiryo.ttc");
	textSpr.drawText("\̈");
	textSpr.entryFirst(drawWin, &scene, &camera);
	textSpr.setPositionLT(-480.0, 272.0);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	return;
}

void OthelloApp::setupBoard(void)
{
	// ̂̐ݒ
	block.makeBlock(90.0, 5.0, 90.0),
	blockModel.setShape(&block);
	blockModel.setMaterial(Green);
	blockModel.glTranslate(0.0, -2.6, 0.0);

	// Obh
	fk_Vector	posA, posB;
	for(int i = 0; i < 9; ++i) {
		posA.set(-40.0 + i*10.0, 0.0, -40.0);
		posB.set(-40.0 + i*10.0, 0.0,  40.0);
		grid.pushLine(posA, posB);
		posA.set(-40.0, 0.0, -40.0 + i*10.0);
		posB.set( 40.0, 0.0, -40.0 + i*10.0);
		grid.pushLine(posA, posB);
	}
	gridModel.setShape(&grid);
	gridModel.setLineColor(0.0, 0.0, 0.0);
	gridModel.setWidth(2.0);

	return;
}

// NbNꏊ̍WlԂ
// ToDo: }XڂYɉlɕ␳A͈͊O`FbNcc
fk_Vector OthelloApp::clickProc(void)
{
	fk_Plane	plane;
	fk_Vector	winPos, projPos;

	plane.setPosNormal(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 1.0, 0.0));
	winPos = eveMan.getMousePosition();
	drawWin->getProjectPosition(winPos.x, winPos.y, &plane, &projPos);

	// projPosɍWl̂ŁA
	// ̃^C~OňԉΗǂ

	// W̕\
	textSpr.drawText(fk_StrPrintf("put (%f, %f, %f)", projPos.x, projPos.y, projPos.z), true);
	textSpr.setPositionLT(-480.0, 272.0);

	return projPos;
}

// ΂u
// ToDo: ł͒vIȃoOAvectorgČɂ
int OthelloApp::makeStone(const fk_Vector &argPos)
{
	// stoneNumԖڂ̃fɌ`ƃXP[Zbg
	sphModel[stoneNum].setShape(&sph);
	sphModel[stoneNum].setScale(1.0, 0.25, 1.0);
	sphModel[stoneNum].setSmoothMode(true);
	// Ԗڂ͍AԖڂ͔ɂ
	if(stoneNum % 2 == 0) {
		sphModel[stoneNum].setMaterial(GlossBlack);
	} else {
		sphModel[stoneNum].setMaterial(White);
	}
	// œnĂWɔzu
	sphModel[stoneNum].glMoveTo(argPos);
	// V[ɃGg[
	scene.entryModel(&sphModel[stoneNum]);

	// ̉Z
	++stoneNum;

	return stoneNum;
}

// t[̏
bool OthelloApp::update(void)
{
	// J̉]
	tb.update();
	// Cg̉]
	lightModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.01);

	// }EXꂽ炻̏ꏊɐ΂u
	if(eveMan.getMouseStatus(FK_MOUSE1) == FKUT_SW_DOWN) {
		makeStone(clickProc());
	}
	// }EXꂽ炻̏ꏊɐ΂u
	if(eveMan.getSpecialKeyStatus(FK_F1) == FKUT_SW_DOWN) {
		if(loadState()) {
			cout << "Load success." << endl;
		} else {
			cout << "Load failed." << endl;
		}
	}
	if(eveMan.getSpecialKeyStatus(FK_F2) == FKUT_SW_DOWN) {
		if(saveState()) {
			cout << "Save success." << endl;
		} else {
			cout << "Save failed." << endl;
		}
	}

	return true;
}

bool OthelloApp::saveState(void)
{
	ofstream	out_file("fileIO.txt");

	if(!out_file.is_open()) return false;

	out_file << "o͂̃eXg" << endl;
	out_file << "hogehoge,hugahuga,hoehoe" << endl;

	out_file.close();

	return true;
}

bool OthelloApp::loadState(void)
{
	ifstream		in_file("fileIO.txt");
	string			str;
	vector<string>	strSplit;

	if(!in_file.is_open()) return false;

	while(getline(in_file, str)) {
		cout << str << endl;
		strSplit = fk_StrSplit(str, ",");
		for(int i = 0; i < strSplit.size(); ++i) {
			cout << strSplit[i] << endl;
		}
	}

	in_file.close();

	return true;
}